<template>
  <div :class="{'input-focused': focused, 'show-label': valueNotEmpty}">
    <label :for="id" class="base-label">
      {{ label }}
    </label>
    <div
      class='base-input-wrapper'
    >
      <textarea
        :id="id"
        class="base-input"
        v-bind="$attrs"
        :placeholder="$attrs.placeholder"
        :value="value"
        @focus="focusHandler"
        @input="inputHandler"
        @blur="blurHandler"
      ></textarea>
    </div>
  </div>
</template>

<script>
export default {
  props: {
    value: {
      type: String,
      default: ''
    },

    id: {
      type: String,
      default: ''
    },

    label: {
      type: String,
      default: ''
    },


  },

  data() {
    return {
      focused: false,
    }
  },

  computed: {
    valueNotEmpty() {
      return this.value.length > 0
    }
  },

  methods: {
    inputHandler(event) {
      this.$emit('input', event.target.value)
    },

    focusHandler() {
      this.focused = true
    },

    blurHandler() {
      this.focused = false
    }
  }
}
</script>

<style lang='scss' scoped>

.base-input-wrapper {
  border-bottom: 2px solid #3A4675;
  width: 100%;
  padding: 18px 0 18px;
  transition: all 0.5s;
}

.base-input {
  width: 100%;
  margin: 0;
  border: none;
  outline: none;
  padding: 0;
  background: transparent;
  font-size: 20px;
  color: #FFFFFF;
  resize: none;
}

.base-input::placeholder ,{
  color: rgba(255, 255, 255, 0.45);
  font-size: 20px;
  font-weight: 300;
}

label {
  font-weight: 300;
  font-size: 16px;
  color: rgba(255, 255, 255, 0.45);
  opacity: 0;
  transition: all 0.5s;
}

.show-label {
  label {
    opacity: 1;
  }
}

.input-focused {
  .base-input-wrapper {
    border-bottom: 2px solid #438AF9;
  }

  label {
    color: #438AF9;
  }
}

</style>
